;###########################################################################################

; *WindowFromPoint*  -  review by kero
;  draft v.2011-04-21
;  (tested: Windows 7 SP1 x86 Home Basic)
;  http://files.rsdn.ru/42164/windowfrompoint_review.zip

;###########################################################################################

; PtInRect_
; GetWindowRect_
; HT_name
; HTShapeProc
; HT_region_info
; FixFrame
; WindowFromPointEx
; RealWindowFromPoint
; Winfo
; GetWindowTree        ;  z-ord
; GetWindowTreeUp      ;  z-up
; GetWindowTreeDown    ;  z-down
; UpdateMenu
; RefreshInfo
; SubClassLayoutrtl
; SubClassListBox
; OnMove
; DlgProc3
; DlgProc2
; ThreadProc
; OnInit
; DlgProc

;###########################################################################################

; \masm32\bin\ml /c /coff /I\masm32\include %NAME%.asm
; \masm32\bin\link /subsystem:windows /libpath:\masm32\lib %NAME%.obj rsrc.obj

.386
.model flat,stdcall
option casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32
inclib shell32
inclib comctl32

.const
 DWMWA_EXTENDED_FRAME_BOUNDS equ 9
 DWMWA_NCRENDERING_ENABLED   equ 1
 id        equ 100
 id2       equ 200

.data
 _app       db "*WindowFromPoint*   -  review  by  kero    (v 2011-04-21)",0
 _wait      db "WAIT ...",0
 _url_0     db "http://blogs.msdn.com/b/oldnewthing/archive/2010/12/30/10110077.aspx",0
 _url_1     db "http://files.rsdn.ru/42164/wintreesnap.zip",0
 _url_2     db "http://files.rsdn.ru/42164/htspy.zip",0
 _Dwmapi    db "Dwmapi",0
 _DwmGWA    db "DwmGetWindowAttribute",0
 _DwmICE    db "DwmIsCompositionEnabled",0
 _open      db "open",0 
 _rundll    db "rundll32.exe",0 
 _param     db "shell32.dll,Control_RunDLL desk.cpl,,2",0
 _button    db "BUTTON",0
 _static    db "STATIC",0
 _htshape   db "HTShape",0
 _winrect   db "__",0
 _dwp       db "dw",0
 _sm        db "sm",0
 _none      db "none",0
 _null      db "null",0
 _simple    db "simple",0
 _complex   db "complex",0
 _other     db "Other thread",0
 _rq        db " R ?",0 
 _layoutrtl db "RealChildWindowFromPoint  ",13,10
            db "MapWindowPoints  ",13,10
            db "WS_EX_LAYOUTRTL  ",0            
 _layered   db "*WFP*,   WS_EX_LAYERED",13,10
            db " and  color scheme  as  a  filter :",0
 _lwa1      db "LWA.1  ",13,10,"  ws_ex_transparent",0
 _lwa2      db "LWA.2  ",13,10,"  alpha=0",0
 _lwa3      db "LWA.3  ",13,10,"  colorkey",0
 _ulw1      db "ULW.",13,10,"1",0
 _ulw2      db "ULW.",13,10,"2",0
 _ulw3      db "ULW.",13,10,"3",0
;_wfp       db ">=WrxRCXidt",0
;_wfp       db "~=WrxRCXidt",0
 _wfp       db "           ",0
;_status    db "^tlvep 11",0
 _status    db "    vep 1.",0
 _timer     db "-timer",0
 _frame     db "-fr",0
 _fixhw     db " hw",0 
 _fixpid    db " pid",0
 _fixpt     db " pt",0 
 _rect      db " rt",0
 _rgn       db " rg",0
 _inv       db " i",0
 _dis       db " d",0
 _transp    db " t",0
 _topl      db " topl",0
 _enum      db "*enum",0
 _zord      db " z-ord",0
 _up        db " z-up",0
 _down      db " z-down",0
 _mess      db "message-only:",0
 _head      db "  n  wl    ws  in r  dw/sm  pv rv  pid  tid   id    owner     parent    hwnd     'class' 'text' 'exe' [left,top, wdth*hght]",0
 _ft        db "%s%4.d%4.d%s%2.d%4.d/%2.d%3.d  %d%6.4d%6.4d%6.4d%10.8lX%10.8lX%10.8lX '%s' '%s' '%s' [%d,%d, %d*%d]",0
 _more      db  "hwnd:%8.8lX  style:%8.8lX  exstyle:%8.8lX  clstyle:%8.8lX  wnd/clsExtra:%d/%d  userdata:%8.8lX  [%d,%d, %d*%d]",0
 _dd        db " %d,"
 _d         db "%d"
 _z         db 0 
 _ftht      db "%s HT_%d: [%d,%d, %d*%d] [%s region]",0
 _ft2       db "%8.8lX (%d,%d) %s %s",0
 _u_g       db "user:%d",13,10,"gdi:  %d",0
 _imm       db " [ Current  DBCS  &&  IMM ]",13,10
            db " Double Byte Character Set :  0",13,10
            db " Input Method Manager :        0",0
 _ime       db "Check  such  calculation :",13,10
            db "IME = 0   -->   Enum = Z-order",0
 _HTarea \
            db "HTERROR",0
            db "HTTRANSPARENT",0
            db "HTNOWHERE",0
            db "HTCLIENT",0
            db "HTCAPTION",0
            db "HTSYSMENU",0
            db "HTGROWBOX",0      ; HTSIZE
            db "HTMENU",0
            db "HTHSCROLL",0
            db "HTVSCROLL",0
            db "HTMINBUTTON",0    ; HTREDUCE
            db "HTMAXBUTTON",0    ; HTZOOM
            db "HTLEFT",0         ; HTSIZEFIRST
            db "HTRIGHT",0
            db "HTTOP",0
            db "HTTOPLEFT",0
            db "HTTOPRIGHT",0
            db "HTBOTTOM",0
            db "HTBOTTOMLEFT",0
            db "HTBOTTOMRIGHT",0  ; HTSIZELAST
            db "HTBORDER",0
            db "HTOBJECT",0       ; (where ??)
            db "HTCLOSE",0
            db "HTHELP",0
 logfont    LOGFONT <-11,0,0,0,400,0,0,0,1,0,0,0,0,"Courier New">

.data?
  hinst     dd ?
  hwnd      dd ?
  hwlb      dd ?
  hw1       dd ?
  hw2       dd ?
  hw3       dd ?
  hw4       dd ?
  hw5       dd ?
  hw6       dd ?
  hw7       dd ?
  hwdesk    dd ?
  hwmess    dd ?
  hwbottom  dd ?
  hwright   dd ?
  hwtop     dd ?
  hwleft    dd ?
  curhw     dd ?
  fixhw     dd ?
  fixpid    dd ?
  fixpt     dd ?
  rgnflag   dd ?
  leftinit  dd ?
  topinit   dd ?
  winlevel  dd ?
  count     dd ?
  timer     dd ?
  frame     dd ?
  rect      dd ?
  rgn       dd ?
  inv       dd ?
  dis       dd ?
  transp    dd ?
  topl      dd ?
  rad       dd ?
  nc_test   dd ?
  oldtick   dd ?
  olditem   dd ?
  hmenubar  HMENU ?
;  hmenupop1 HMENU ?
;  hmenupop2 HMENU ?
  hfnt      HFONT ?
  hfont     HFONT ?
  hrgn      HRGN ?
  hregion   HRGN ?
  hbrush    HBRUSH ?
  point     POINT <>  ; fixed point

.code

;###########################################################################################
; instead of GetWindowRect
; for Vista/Win7/...

GetWindowRect_ proc uses ebx hWnd:HWND,lprect:DWORD
  local var:DWORD
  invoke GetModuleHandle,offset _Dwmapi
  test eax,eax
  jz @f
  mov ebx,eax
  invoke GetProcAddress,ebx,offset _DwmICE
  test eax,eax
  jz @f
  lea edx,var
  push edx
  call eax
  cmp eax,S_OK
  jnz @f
  mov eax,var
  test eax,eax
  jz @f
  invoke GetProcAddress,ebx,offset _DwmGWA
  test eax,eax
  jz @f
  push sizeof RECT
  push lprect
  push DWMWA_EXTENDED_FRAME_BOUNDS
  push hWnd
  call eax
  cmp eax,S_OK
  jz @@@
@@:
  invoke GetWindowRect,hWnd,lprect
@@@:
  ret
GetWindowRect_ endp

;###########################################################################################

; instead of PtInRect()

PtInRect_ proc lprect:DWORD, ptx:DWORD, pty:DWORD
  mov ecx,lprect
  assume ecx:PTR RECT
  xor eax,eax
  mov edx,ptx
  cmp edx,[ecx].left
  jl @f
  cmp edx,[ecx].right
  jge @f
  mov edx,pty
  cmp edx,[ecx].top
  jl @f
  cmp edx,[ecx].bottom
  jge @f
  inc eax
@@:
  assume ecx:nothing
  ret
PtInRect_ endp

;###########################################################################################

UserGdiCount proc uses ebx edi
  local buf[128]:BYTE
  invoke GetCurrentProcessId
	invoke OpenProcess,PROCESS_ALL_ACCESS,FALSE,eax
	mov ebx,eax
	invoke GetGuiResources,ebx,GR_USEROBJECTS
	mov edi,eax
	invoke GetGuiResources,ebx,GR_GDIOBJECTS	
  invoke wsprintf,addr buf,offset _u_g,edi,eax
  invoke SetDlgItemText,hwnd,id-16,addr buf
	invoke CloseHandle,ebx
  ret
UserGdiCount endp

;###########################################################################################

HT_name proc lpstr:LPSTR,HT:DWORD
  local buf[16]:BYTE
  mov ecx,HT
  add ecx,2
  .if ecx>=0 && ecx<=23
    mov eax,offset _HTarea
    .while ecx!=0
@@:
      mov dl,byte ptr [eax]
      inc eax
      test dl,dl
      jnz @b
      dec ecx
    .endw
  .else
    invoke wsprintf,addr buf,offset _d,HT
    lea eax,buf
  .endif
  invoke lstrcpy,lpstr,eax
  ret
HT_name endp

;###########################################################################################

HTShapeProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  .if uMsg==WM_SETCURSOR
    invoke LoadCursor,0,IDC_HELP
    invoke SetCursor,eax
  .elseif uMsg==WM_NCRBUTTONUP
    invoke DestroyWindow,hWnd
    xor eax,eax
  .elseif uMsg==WM_NCLBUTTONDBLCLK
    invoke GetWindowLong,hWnd,GWL_STYLE
    xor eax,WS_BORDER
    invoke SetWindowLong,hWnd,GWL_STYLE,eax
    invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE
    xor eax,eax
  .else
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
    .if uMsg==WM_NCHITTEST
      mov eax,HTCAPTION
    .endif
  .endif
  ret
HTShapeProc endp

;###########################################################################################

HT_region_info proc uses ebx edi esi hWnd:HWND,lpbuf:DWORD,HT:DWORD,param:DWORD   ; ,param2:DWORD,param3:DWORD
  local hr:HRGN
  local hrg:HRGN      ; combination of all regions
	local Inline:DWORD  ; inline region state
	local rt:RECT
	local rt2:RECT
  local Wdth:DWORD
  local Hght:DWORD
  local retval:DWORD
  local bu[16]:BYTE
  local buf[16]:BYTE

  .if param==0
    mov ecx,offset _dwp
  .else
    mov ecx,offset _sm
  .endif
  invoke lstrcpy,addr bu,ecx

  .if nc_test==0
    invoke GetWindowRect_,hWnd,addr rt
  .else
    invoke GetWindowRect,hWnd,addr rt
  .endif

  mov eax,rt.right
  sub eax,rt.left
  mov Wdth,eax
  mov eax,rt.bottom
  sub eax,rt.top
  mov Hght,eax
	xor ebx,ebx  ; start location of a region
	xor edi,edi  ; X
	xor esi,esi  ; Y
	mov Inline,ebx
	mov hrg,ebx
	.while esi< Hght
		.while edi<= Wdth
      mov eax,rt.left
      add eax,edi
      mov ecx,rt.top
      add ecx,esi

;      .if param2!=0
;        push eax
;        push ecx
;        invoke SetCursorPos,eax,ecx
;        pop ecx
;        pop eax
;      .endif

      and eax,0ffffh
      shl ecx,16
      or ecx,eax

      .if param==0
        invoke DefWindowProc,hWnd,WM_NCHITTEST,0,ecx
      .else
        invoke SendMessageTimeout,hWnd,WM_NCHITTEST,0,ecx,SMTO_ABORTIFHUNG,300,addr retval
        mov eax,retval
      .endif

			.if eax!=HT
				jmp @f
			.elseif edi==Wdth
@@:
				.if Inline!=0
					mov Inline,0
					mov eax,esi
					inc eax
					invoke CreateRectRgn,ebx,esi,edi,eax
					.if hrg==0
						mov hrg,eax
					.else
            push eax
						invoke CombineRgn,hrg,hrg,eax,RGN_OR
						call DeleteObject
					.endif
				.endif
			.else
				.if Inline==0
					inc Inline
					mov ebx,edi
				.endif
			.endif
			inc edi
		.endw
		inc esi
		xor edi,edi
		invoke GetAsyncKeyState,VK_ESCAPE
    and eax,8000h
    .break .if (eax)
	.endw
	
  .if hrg!=0

;    .if param3!=0
;      invoke CreateRectRgn,0,0,0,0
;      mov hr,eax
;      invoke GetWindowRgn,hWnd,hr
;      mov ebx,eax
;      invoke CreateRectRgn,0,0,0,0
;      push eax
;      .if ebx!=ERROR && ebx!=NULLREGION
;        mov eax,hr
;      .endif
;      invoke CombineRgn,hrg,hrg,eax,RGN_AND
;      call DeleteObject
;      invoke DeleteObject,hr
;    .endif

;;    invoke GetRegionData,hrg,0,0
;;    mov edi,eax ; dwCount
;;    invoke VirtualAlloc,0,edi,MEM_COMMIT,PAGE_READWRITE
;;    mov esi,eax ; lpRgnData
;;    invoke GetRegionData,hrg,edi,esi
;;    ...
;;    invoke VirtualFree,esi,0,MEM_RELEASE

    mov edi,rt.left
    mov esi,rt.top
    invoke GetRgnBox,hrg,addr rt
    mov ebx,eax
    mov edx,rt.left
    mov ecx,rt.top
    neg edx
    neg ecx
    add rt.right,edx
    sub edi,edx
    add rt.bottom,ecx
    sub esi,ecx
    invoke OffsetRgn,hrg,edx,ecx

    .if rt.right!=0 && rt.bottom!=0
      invoke HT_name,addr buf,HT
      invoke wsprintf,lpbuf,offset _ft2,hWnd,rt.left,rt.top,addr bu,addr buf
      invoke CreateWindowEx,WS_EX_TOPMOST OR WS_EX_TOOLWINDOW,offset _htshape,lpbuf,WS_POPUP OR WS_VISIBLE OR WS_BORDER,edi,esi,rt.right,rt.bottom,hWnd,0,hinst,0
      mov edi,eax
      invoke SetWindowRgn,edi,hrg,1
      invoke IsWindowVisible,edi
      .if eax==0
        invoke SetWindowLong,edi,GWL_HWNDPARENT,0  ; for root message-only window ("Message" class)
      .endif
      xor eax,eax
      mov rt2.left,eax
      mov rt2.top,eax
      mov eax,rt.right
      mov rt2.right,eax
      mov eax,rt.bottom
      mov rt2.bottom,eax
      invoke GetWindowDC,edi
      mov esi,eax
      invoke RectVisible,esi,addr rt2
      .if eax==0
        invoke SetWindowPos,edi,0,0,0,0,0,SWP_NOZORDER or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE
      .endif
      invoke ReleaseDC,edi,esi
    .else
      invoke DeleteObject,hrg
    .endif
;;    invoke DeleteObject,hrg

    .if ebx==NULLREGION             ; 1
      mov eax,offset _null
    .elseif ebx==SIMPLEREGION       ; 2
      mov eax,offset _simple
    .elseif ebx==COMPLEXREGION      ; 3
      mov eax,offset _complex
    .endif
  .else ; =0
    xor eax,eax
    mov rt.left,eax
    mov rt.top,eax
    mov rt.right,eax
    mov rt.bottom,eax
    mov eax,offset _none
  .endif
  invoke wsprintf,lpbuf,offset _ftht,addr bu,HT,rt.left,rt.top,rt.right,rt.bottom,eax
	ret
HT_region_info endp

;###########################################################################################

FixFrame proc uses ebx edi hWnd:HWND
  local rt:RECT
  .if hWnd!=0
    .if nc_test==0
      invoke GetWindowRect_,hWnd,addr rt
    .else
      invoke GetWindowRect,hWnd,addr rt
    .endif
    dec rt.left
    dec rt.top
    mov ebx,rt.right
    sub ebx,rt.left
    mov edi,rt.bottom
    sub edi,rt.top
    invoke SetWindowPos,hwleft,HWND_TOPMOST,rt.left,rt.top,1,edi,SWP_FRAMECHANGED or SWP_NOACTIVATE or SWP_SHOWWINDOW
    invoke SetWindowPos,hwtop,HWND_TOPMOST,rt.left,rt.top,ebx,1,SWP_FRAMECHANGED or SWP_NOACTIVATE or SWP_SHOWWINDOW
    invoke SetWindowPos,hwright,HWND_TOPMOST,rt.right,rt.top,1,edi,SWP_FRAMECHANGED or SWP_NOACTIVATE or SWP_SHOWWINDOW
    invoke SetWindowPos,hwbottom,HWND_TOPMOST,rt.left,rt.bottom,ebx,1,SWP_FRAMECHANGED or SWP_NOACTIVATE or SWP_SHOWWINDOW
  .else
    invoke IsWindowVisible,hwleft
    .if eax!=0
      push hwleft
      push hwtop
      push hwright
      push hwbottom
      xor edi,edi
      .while edi<=3
        pop eax
        invoke SetWindowPos,eax,0,0,0,0,0,SWP_NOZORDER or SWP_FRAMECHANGED or SWP_NOACTIVATE or SWP_HIDEWINDOW
        inc edi
      .endw
    .endif
  .endif
  ret
FixFrame endp

;###########################################################################################

WindowFromPointEx proc uses ebx ptx:DWORD,pty:DWORD,uFlags:DWORD  ; (ptx, pty - screen coordinates)
 local pt:POINT
 
  mov eax,ptx
  mov pt.x,eax
  mov eax,pty
  mov pt.y,eax
  invoke GetDesktopWindow
  mov ebx,eax
  xor ecx,ecx
  .while TRUE
    invoke MapWindowPoints,ecx,ebx,addr pt,1
    invoke ChildWindowFromPointEx,ebx,pt.x,pt.y,uFlags
  .break .if !(eax!=0 && eax!=ebx)
    mov ecx,ebx
    mov ebx,eax
  .endw
  mov eax,ebx
  ret
WindowFromPointEx endp

;###########################################################################################

RealWindowFromPoint proc uses ebx ptx:DWORD,pty:DWORD  ; (ptx, pty - screen coordinates)
 local pt:POINT
 
  mov eax,ptx
  mov pt.x,eax
  mov eax,pty
  mov pt.y,eax
  invoke GetDesktopWindow
  mov ebx,eax
  xor ecx,ecx
  .while TRUE
    invoke MapWindowPoints,ecx,ebx,addr pt,1
    invoke RealChildWindowFromPoint,ebx,pt.x,pt.y
  .break .if !(eax!=0 && eax!=ebx)
    mov ecx,ebx
    mov ebx,eax
  .endw
  mov eax,ebx
  ret
RealWindowFromPoint endp

;###########################################################################################

Winfo proc uses ebx edi esi hWnd:HWND,lParam:LPARAM
  local pt:POINT
  local rt:RECT
  local rc:RECT
  local pe32:PROCESSENTRY32
  local buff[1024]:BYTE  
  local buf1[64]:BYTE
  local buf2[32]:BYTE
  local bufexe[64]:BYTE
  local wfp_[16]:BYTE
  local status_[16]:BYTE
  local rgntype:DWORD
  local dwp:DWORD  
  local sm:DWORD  
  local pid:DWORD
  local tid:DWORD
  local idhmenu:DWORD
  local pv:DWORD
  local rv:DWORD
  local sel_:DWORD                         
  local hwparent:HWND
  local hwowner:HWND
  local hsnap:HANDLE  

  mov ebx,hWnd

  xor eax,eax
  mov sel_,eax
  mov hwparent,eax
  mov hwowner,eax

  mov eax,point.x
  mov pt.x,eax
  mov eax,point.y
  mov pt.y,eax
  
  .if rad==0
    mov edi,ebx
    xor eax,eax
    mov winlevel,eax
    .if edi==hwdesk || edi==hwmess
      dec winlevel
    .else
@@:
      invoke GetAncestor,edi,GA_PARENT
      .if (eax!=hwdesk && eax!=hwmess && eax!=0)
        mov edi,eax
        inc winlevel
        jmp @b
      .endif      
    .endif
  .endif

  .if winlevel!=-1 && winlevel!=0 && topl!=0
    jmp @@@
  .endif
  
  invoke lstrcpy,addr wfp_,offset _wfp
  invoke lstrcpy,addr status_,offset _status  

  invoke GetWindowThreadProcessId,ebx,addr pid
  mov tid,eax
  mov edx,pid
  .if fixpid!=0 && edx!=fixpid
    jmp @@@
  .endif

  .if nc_test==0
    invoke GetWindowRect_,ebx,addr rt
  .else
    invoke GetWindowRect,ebx,addr rt
  .endif  
  invoke PtInRect_,addr rt,pt.x,pt.y
  .if eax==0  
    mov byte ptr[status_+8],'0'
    .if rect!=0
      jmp @@@
    .endif
  .else
    or sel_,1h
  .endif  

  invoke GetWindowRgn,ebx,hrgn
  mov rgntype,eax
  .if eax!=ERROR
    mov eax,pt.x
    mov ecx,pt.y
    sub eax,rt.left
    sub ecx,rt.top
    invoke PtInRegion,hrgn,eax,ecx
    .if eax==0
      mov al,'0'
      .if rgn!=0
        jmp @@@
      .endif
    .else
      mov al,'1'
      or sel_,2h
    .endif
    mov byte ptr[status_+9],al
  .else
    or sel_,4h
  .endif

  invoke IsWindowVisible,ebx
  .if eax==0
    mov byte ptr[status_+4],'h'
    .if inv!=0
      jmp @@@
    .endif
  .endif

  invoke IsWindowEnabled,ebx
  .if eax==0
    mov byte ptr[status_+5],'d'
    .if dis!=0
      jmp @@@
    .endif
  .endif

  invoke GetWindowLong,ebx,GWL_EXSTYLE
  mov edx,eax
  mov edx,eax
  and edx,WS_EX_TOPMOST
  .if edx!=0
    mov byte ptr[status_],'^'
  .endif
  mov edx,eax
  and edx,WS_EX_COMPOSITED
  .if edx!=0
    mov byte ptr[status_+1],''
  .endif
  mov edx,eax  
  and edx,WS_EX_LAYERED
  .if edx!=0
    mov byte ptr[status_+3],'l'
  .endif
  mov edx,eax
  and eax,WS_EX_TRANSPARENT
  .if eax!=0
    mov byte ptr[status_+2],'t'
    .if transp!=0
      jmp @@@
    .endif
  .endif

  inc count

  invoke GetWindowLong,ebx,GWL_STYLE
  mov ecx,eax
  mov edx,eax
  and ecx,WS_CHILD
  and edx,WS_POPUP
  .if ecx==0 && edx==0
    mov al,'o'
  .elseif ecx==0 && edx!=0
    mov al,'p'
  .elseif ecx!=0 && edx==0
    mov al,'c'
  .elseif ecx!=0 && edx!=0
    mov al,'q'
  .endif
  mov byte ptr[status_+6],al

  invoke GetWindowLong,ebx,GWL_ID         
  and eax,0FFFFh
  mov idhmenu,eax

  mov word ptr[bufexe],[0]['?']
  invoke CreateToolhelp32Snapshot,TH32CS_SNAPPROCESS,pid
  mov hsnap,eax
  mov pe32.dwSize,sizeof pe32 
  invoke Process32First,hsnap,addr pe32 
@1:
  test eax,eax
  jz @f
  mov eax,pid
  cmp pe32.th32ProcessID,eax
  jz @2
  invoke Process32Next,hsnap,addr pe32
  jmp	@1
@2:
  invoke lstrcpy,addr bufexe,addr pe32.szExeFile
@@:
  invoke CloseHandle,hsnap
  
  mov eax,pt.x
  mov edi,pt.y
  shl edi,16
  or edi,eax
  invoke DefWindowProc,ebx,WM_NCHITTEST,0,edi
  mov dwp,eax
  invoke SendMessageTimeout,ebx,WM_NCHITTEST,0,edi,SMTO_ABORTIFHUNG,100,addr sm

  invoke GetWindowDC,ebx
  mov edi,eax
  mov ecx,pt.x
  mov edx,pt.y
  sub ecx,rt.left
  sub edx,rt.top 
  invoke PtVisible,edi,ecx,edx
  mov pv,eax
  mov eax,rt.right
  sub eax,rt.left
  mov rc.right,eax
  mov eax,rt.bottom
  sub eax,rt.top
  mov rc.bottom,eax
  xor eax,eax
  mov rc.left,eax
  mov rc.top,eax
  invoke RectVisible,edi,addr rc
  mov rv,eax
  invoke ReleaseDC,ebx,edi

  xor esi,esi
  invoke IsDlgButtonChecked,hwnd,id-13
  .if eax!=0
    or esi,CWP_SKIPINVISIBLE  ; =1
  .endif
  invoke IsDlgButtonChecked,hwnd,id-14
  .if eax!=0
    or esi,CWP_SKIPDISABLED  ; =2
  .endif
  invoke IsDlgButtonChecked,hwnd,id-15
  .if eax!=0
    or esi,CWP_SKIPTRANSPARENT  ; =4
  .endif

  invoke WindowFromPoint,pt.x,pt.y  
  .if eax==ebx
    mov byte ptr[wfp_+2],'W'
  .endif

  invoke RealWindowFromPoint,pt.x,pt.y  
  .if eax==ebx
    mov byte ptr[wfp_+3],'r'
  .endif

  invoke WindowFromPointEx,pt.x,pt.y,esi
  .if eax==ebx
    mov byte ptr[wfp_+4],'x'
  .endif

  .if fixhw!=0
    invoke IsWindow,fixhw
    .if eax==0
      mov fixhw,eax
    .else
      .if ebx==fixhw
        mov byte ptr[wfp_+1],'='
      .endif
    .endif
  .endif

  .if ebx!=hwdesk && ebx!=hwmess

    invoke GetWindow,ebx,GW_OWNER
    mov hwowner,eax

    invoke GetAncestor,ebx,GA_PARENT
    mov hwparent,eax

    .if nc_test!=0 && (eax==hwdesk || eax==hwmess)
      mov edi,ebx
    .else
      mov edi,hwparent
    .endif

    invoke MapWindowPoints,0,edi,addr pt,1

    invoke RealChildWindowFromPoint,edi,pt.x,pt.y
    .if eax==ebx
      mov byte ptr[wfp_+5],'R'
    .endif
    invoke ChildWindowFromPoint,edi,pt.x,pt.y
    .if eax==ebx
      mov byte ptr[wfp_+6],'C'
    .endif
    invoke ChildWindowFromPointEx,edi,pt.x,pt.y,esi
    .if eax==ebx
      mov byte ptr[wfp_+7],'X'
    .else
      invoke ChildWindowFromPointEx,edi,pt.x,pt.y,CWP_SKIPINVISIBLE
      .if eax==ebx
        mov byte ptr[wfp_+8],'i'
      .else
        invoke ChildWindowFromPointEx,edi,pt.x,pt.y,CWP_SKIPDISABLED
        .if eax==ebx
          mov byte ptr[wfp_+9],'d'
        .else
          invoke ChildWindowFromPointEx,edi,pt.x,pt.y,CWP_SKIPTRANSPARENT
          .if eax==ebx
            mov byte ptr[wfp_+10],'t'
          .else
            invoke ChildWindowFromPointEx,edi,pt.x,pt.y,CWP_SKIPINVISIBLE or CWP_SKIPDISABLED
            .if eax==ebx
              mov byte ptr[wfp_+8],'i'
              mov byte ptr[wfp_+9],'d'
            .else
              invoke ChildWindowFromPointEx,edi,pt.x,pt.y,CWP_SKIPDISABLED or CWP_SKIPTRANSPARENT
              .if eax==ebx
                mov byte ptr[wfp_+9],'d'
                mov byte ptr[wfp_+10],'t'
              .else
                invoke ChildWindowFromPointEx,edi,pt.x,pt.y,CWP_SKIPINVISIBLE or CWP_SKIPTRANSPARENT
                .if eax==ebx
                  mov byte ptr[wfp_+8],'i'
                  mov byte ptr[wfp_+10],'t'
                .else
                  invoke ChildWindowFromPointEx,edi,pt.x,pt.y,CWP_SKIPINVISIBLE or CWP_SKIPDISABLED or CWP_SKIPTRANSPARENT
                  .if eax==ebx
                    mov byte ptr[wfp_+8],'i'
                    mov byte ptr[wfp_+9],'d'
                    mov byte ptr[wfp_+10],'t'
                  .endif
                .endif
              .endif
            .endif
          .endif
        .endif
      .endif
    .endif
  .else
  .endif

  invoke GetClassName,ebx,addr buf1,63
  invoke SendMessageTimeout,ebx,WM_GETTEXT,31,addr buf2,SMTO_ABORTIFHUNG,100,0

  .if (sel_==3h || sel_==5h) ; && ebx!=curhw
    mov byte ptr[wfp_],'>'
  .endif

  .if ebx==curhw
    mov byte ptr[wfp_],'~'
  .endif

  mov ecx,rt.right
  sub ecx,rt.left
  mov edx,rt.bottom
  sub edx,rt.top

  invoke wsprintf,addr buff,offset _ft,addr wfp_,count,winlevel,addr status_,rgntype,dwp,sm,pv,rv,pid,tid,idhmenu,hwowner,hwparent,ebx,addr buf1,addr buf2,addr bufexe,rt.left,rt.top,ecx,edx

  invoke SendMessage,hwlb,LB_ADDSTRING,0,addr buff
  mov edi,eax
  invoke SendMessage,hwlb,LB_SETITEMDATA,eax,ebx
  .if ((sel_==3h || sel_==5h) && timer==0) || ebx==fixhw
    invoke SendMessage,hwlb,LB_SETSEL,TRUE,edi
  .endif

@@@:
  xor eax,eax
  inc eax
  ret
Winfo endp

;###########################################################################################

;FindWindowTree proc uses ebx edi hWnd:HWND  ; (Z-order via FindWindowEx)
;  mov eax,hWnd
;  mov winlevel,-2
;
;@inc:
;  inc winlevel
;@0:
;  mov ebx,eax
;  
;  invoke IsWindow,ebx
;  test eax,eax
;  jz @f
;
;  invoke Winfo,ebx,0
;  
;  invoke IsWindow,ebx
;  test eax,eax
;  jz @f
;
;  invoke FindWindowEx,ebx,0,0,0  ; (child-1)
;  test eax,eax
;  jnz @inc
;@dec:
;
;  invoke IsWindow,ebx
;  test eax,eax
;  jz @f
;
;  invoke GetAncestor,ebx,GA_PARENT
;  mov edi,eax
;
;  invoke IsWindow,edi
;  test eax,eax
;  jz @f
;
;  invoke FindWindowEx,edi,ebx,0,0  ; (next)
;  test eax,eax
;  jnz @0
;  mov ebx,edi
;  dec winlevel
;  cmp ebx,hWnd
;  jnz @dec
;@@:
;  ret
;FindWindowTree endp

;###########################################################################################

GetWindowTree proc uses ebx hWnd:HWND

  mov eax,hWnd
  mov winlevel,-2
@inc:
  inc winlevel
@0:
  mov ebx,eax
  
  invoke IsWindow,ebx
  test eax,eax
  jz @f  
  
  invoke Winfo,ebx,0
  
  invoke IsWindow,ebx
  test eax,eax
  jz @f  
  
  invoke GetWindow,ebx,GW_CHILD  ; (child-1)
  test eax,eax
  jnz @inc
@dec:

  invoke IsWindow,ebx
  test eax,eax
  jz @f

  invoke GetWindow,ebx,GW_HWNDNEXT
  test eax,eax
  jnz @0
  
  invoke IsWindow,ebx
  test eax,eax
  jz @f

  invoke GetAncestor,ebx,GA_PARENT
  mov ebx,eax
  dec winlevel
  cmp ebx,hWnd
  jnz @dec
@@:
  ret
GetWindowTree endp

;###########################################################################################

GetWindowTreeUp proc uses ebx hWnd:HWND

  mov eax,hWnd
  mov winlevel,-1
@inc:
  inc winlevel
  mov ebx,eax
  
  invoke IsWindow,ebx
  test eax,eax
  jz @f

  invoke GetWindow,ebx,GW_CHILD
  test eax,eax
  jnz @inc
@dec:
  dec winlevel
  
  invoke IsWindow,ebx
  test eax,eax
  jz @f

  invoke Winfo,ebx,0
  cmp ebx,hWnd
  jz @f
  
  invoke IsWindow,ebx
  test eax,eax
  jz @f

  invoke GetWindow,ebx,GW_HWNDNEXT
  test eax,eax
  jnz @inc
  
  invoke IsWindow,ebx
  test eax,eax
  jz @f

  invoke GetAncestor,ebx,GA_PARENT
  mov ebx,eax
  jmp @dec
@@:
  ret
GetWindowTreeUp endp

;###########################################################################################

GetWindowTreeDown proc uses ebx hWnd:HWND

  mov eax,hWnd
  mov winlevel,-2
@inc:
  inc winlevel
@0:
  mov ebx,eax
  
  invoke IsWindow,ebx
  test eax,eax
  jz @f

  invoke Winfo,ebx,0
  
  invoke IsWindow,ebx
  test eax,eax
  jz @f
  
  invoke GetWindow,ebx,GW_CHILD
  invoke GetWindow,eax,GW_HWNDLAST
  test eax,eax
  jnz @inc
@dec:

  invoke IsWindow,ebx
  test eax,eax
  jz @f

  invoke GetWindow,ebx,GW_HWNDPREV
  test eax,eax
  jnz @0
  
  invoke IsWindow,ebx
  test eax,eax
  jz @f

  invoke GetAncestor,ebx,GA_PARENT
  mov ebx,eax
  dec winlevel
  cmp ebx,hWnd
  jnz @dec
@@:
  ret
GetWindowTreeDown endp

;###########################################################################################

UpdateMenu proc uses edi esi

  invoke GetMenu,hwnd
  mov esi,eax
  push frame
  push offset _frame   ; id+16
  push fixhw
  push offset _fixhw   ; id+9
  push rect
  push offset _rect    ; id+8
  push timer
  push offset _timer   ; id+7
  push fixpid
  push offset _fixpid  ; id+6
  push fixpt
  push offset _fixpt   ; id+5
  push rgn
  push offset _rgn     ; id+4
  push transp
  push offset _transp  ; id+3
  push dis
  push offset _dis     ; id+2
  push inv
  push offset _inv     ; id+1
  push topl
  push offset _topl    ; id
  mov edi,id
  
  .while edi<=id+10
    pop edx
    pop eax
    .if eax==0
      .if edi==id+7 || edi==id+10
        mov al,'-'
      .else
        mov al,' '
      .endif
    .else
      .if edi>=id+1 && edi<=id+3
        mov al,'-'
      .else
        mov al,'+'
      .endif
    .endif
    mov cl,byte ptr[edx]
    .if al!=cl
      mov byte ptr[edx],al
      .if edi==id+10
        mov edi,id+16
      .endif
      invoke ModifyMenu,esi,edi,MF_BYCOMMAND or MF_STRING,edi,edx
    .endif
    inc edi
  .endw
  push offset _down
  push offset _up
  push offset _zord
  push offset _enum
  mov edi,id+10  
  .while edi<=id+13
    pop edx
    mov eax,edi
    sub eax,id+10
    .if eax==rad
      mov al,'*'
    .else
      mov al,' '
    .endif
    mov byte ptr[edx],al
    invoke ModifyMenu,esi,edi,MF_BYCOMMAND or MF_STRING,edi,edx
    inc edi
  .endw
  invoke DrawMenuBar,hwnd
  ret
UpdateMenu endp

;###########################################################################################

RefreshInfo proc uses ebx edi index:DWORD
  local pt:POINT
  local rt:RECT
  local buf[256]:BYTE

  .if index==-1
    invoke SendMessage,hwlb,LB_GETTOPINDEX,0,0
    mov index,eax
  .endif

  invoke UserGdiCount

  invoke GetCursorPos,addr pt
  invoke RealWindowFromPoint,pt.x,pt.y
  mov curhw,eax

  invoke IsWindow,fixhw
  .if eax==0
    mov fixhw,eax
  .endif

  .if frame==0
    mov eax,fixhw
  .else
    mov eax,curhw
  .endif
  invoke FixFrame,eax

  invoke GetKeyState,VK_SHIFT
  and eax,8000h
  mov nc_test,eax

  invoke GetKeyState,VK_CONTROL
  and eax,8000h
  .if eax!=0 && fixpt==0
    .if fixhw==0
      mov eax,curhw
      mov fixhw,eax
      invoke SendMessage,hwnd,WM_COMMAND,id+30,0
    .endif
    inc fixpt
    invoke UpdateMenu
    jmp @f
  .elseif eax==0 && fixpt==0
@@:
    mov eax,pt.x
    mov point.x,eax
    mov eax,pt.y
    mov point.y,eax
    invoke wsprintf,addr buf,offset _dd,point.x,point.y
    invoke SetDlgItemText,hwnd,id-11,addr buf
  .endif

  invoke SendMessage,hwlb,WM_SETREDRAW,FALSE,0
  invoke SendMessage,hwlb,LB_RESETCONTENT,0,0

  push hwmess
  push hwdesk
  xor edi,edi    
  .while edi<=1
    xor eax,eax
    mov count,eax
    pop ebx
    .if rad==0
      invoke Winfo,ebx,0
      invoke EnumChildWindows,ebx,offset Winfo,0
    .elseif rad==1
      invoke GetWindowTree,ebx
    .elseif rad==2
      invoke GetWindowTreeUp,ebx
    .elseif rad==3      
      invoke GetWindowTreeDown,ebx
    .endif
    .if edi==0
      invoke SendMessage,hwlb,LB_ADDSTRING,0,offset _mess
    .endif
    inc edi
  .endw
  invoke SendMessage,hwlb,LB_ADDSTRING,0,offset _z
  invoke SendMessage,hwlb,LB_SETTOPINDEX,index,0

  invoke SendMessage,hwlb,WM_SETREDRAW,TRUE,0
  invoke RedrawWindow,hwlb,0,0,RDW_ERASE or RDW_FRAME or RDW_INVALIDATE or RDW_ALLCHILDREN
  ret
RefreshInfo endp

;###########################################################################################

SubClassLayoutrtl proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  local rt:RECT

  mov eax,wParam
  mov edx,lParam
  shr edx,16
  .if uMsg==WM_SETCURSOR && eax!=hWnd && dx==WM_LBUTTONDOWN
    mov ecx,SC_SIZE+9
    jmp @f
  .elseif uMsg==WM_SETCURSOR && eax!=hWnd && dx==WM_RBUTTONDOWN
    mov ecx,SC_SIZE+8
@@:
    invoke DefWindowProc,eax,WM_SYSCOMMAND,ecx,0
    invoke InvalidateRect,hWnd,0,1
  .endif
  invoke GetWindowLong,hWnd,GWL_USERDATA
  invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
  .if uMsg==WM_PAINT
    invoke GetClientRect,hWnd,addr rt
    mov esi,rt.right
    invoke GetWindow,hWnd,GW_CHILD
    mov edi,eax
    invoke GetWindowRect_,edi,addr rt
    invoke MapWindowPoints,0,hWnd,addr rt,2    
    mov edx,rt.right
    sub esi,edx
    sub edx,rt.left
    add edx,esi
    mov rt.left,esi
    mov rt.right,edx
    invoke GetDC,hWnd
    mov ebx,eax
    invoke GetStockObject,BLACK_BRUSH
    invoke FrameRect,ebx,addr rt,eax    
    invoke ReleaseDC,hWnd,ebx
  .endif
  ret
SubClassLayoutrtl endp

;###########################################################################################

SubClassListBox proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local buf[256]:BYTE

  .if uMsg==WM_LBUTTONDOWN
    invoke SendMessage,hWnd,LB_ITEMFROMPOINT,0,lParam
    mov edi,eax
    invoke SendMessage,hWnd,LB_GETCOUNT,0,0
    .if edi>=eax
      mov byte ptr[buf],0
    .else
      invoke SendMessage,hWnd,LB_GETTEXT,edi,addr buf
    .endif
    invoke SetDlgItemText,hwnd,id-10,addr buf
    jmp @f

  .elseif uMsg==WM_RBUTTONDOWN
    mov esi,wParam
    invoke SendMessage,hWnd,LB_ITEMFROMPOINT,0,lParam
    mov edi,eax
    invoke SendMessage,hWnd,LB_GETITEMDATA,edi,0
    mov ebx,eax
    invoke IsWindow,ebx
    .if eax!=0
      invoke SendMessage,hWnd,LB_GETTOPINDEX,0,0   
      mov edx,eax 
      .if ebx==fixhw
        xor eax,eax
        mov fixhw,eax
        invoke FixFrame,eax
      .else
        mov fixhw,ebx
        .if esi==(MK_LBUTTON or MK_RBUTTON)
          invoke GetWindowThreadProcessId,ebx,addr fixpid
          xor edx,edx
        .endif
      .endif
      invoke RefreshInfo,edx
      invoke UpdateMenu
      invoke SendMessage,hWnd,LB_SETSEL,TRUE,edi
    .endif
    xor eax,eax
    
  .elseif uMsg==WM_MBUTTONDOWN
    invoke SendMessage,hWnd,LB_ITEMFROMPOINT,0,lParam
    invoke SendMessage,hWnd,LB_GETITEMDATA,eax,0
    mov ebx,eax
    .if fixhw!=0
      invoke IsWindow,fixhw
      .if eax!=0
        mov esi,fixhw
      .else
        mov fixhw,eax
        jmp @f
      .endif
    .else
      invoke GetWindow,ebx,GW_HWNDPREV
      mov esi,eax
    .endif
    invoke SetWindowPos,esi,ebx,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE
    invoke RefreshInfo,-1
    xor edi,edi
    .while TRUE
      invoke SendMessage,hWnd,LB_GETITEMDATA,edi,0
      .break .if (eax==ebx || eax==LB_ERR)
      inc edi
    .endw
    invoke SendMessage,hWnd,LB_SETSEL,TRUE,edi
    xor eax,eax
    
  .elseif uMsg==WM_MOUSEWHEEL
    invoke PostMessage,hwnd,uMsg,wParam,lParam
    xor eax,eax

  .else
@@:
    invoke GetWindowLong,hWnd,GWL_USERDATA
    invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
  .endif
  ret
SubClassListBox endp

;###########################################################################################

OnMove proc uses ebx edi
  local pt:POINT
  push 6         ; x
  push 309       ; y
  push hw1
  push 6
  push 344
  push hw2
  push 6
  push 379
  push hw3
  push 124
  push 309
  push hw4
  push 124
  push 344
  push hw5
  push 124
  push 379
  push hw6
  push 14
  push 184
  push hw7
  xor edi,edi
  .while edi<=6
    pop ebx
    pop pt.y
    pop pt.x
    invoke ClientToScreen,hwnd,addr pt
    invoke SetWindowPos,ebx,0,pt.x,pt.y,0,0,SWP_NOZORDER or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE
    inc edi
  .endw
  ret
OnMove endp

;##########################################################################################

; LWA_COLORKEY  equ 1h
; ULW_COLORKEY  equ 1h
; LWA_ALPHA     equ 2h
; ULW_ALPHA     equ 2h
; ULW_OPAQUE    equ 4h

DlgProc3 proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local rt:RECT
  local pt:POINT
  local ps:PAINTSTRUCT
  local bfs:BLENDFUNCTION
  local hdcmem:HDC
  local oldfnt:HFONT
  local oldbmp:HBITMAP
  local alph:DWORD
  local lrd:DWORD
  local buf[256]:BYTE

  mov esi,hWnd

  .if uMsg==WM_INITDIALOG
    invoke GetWindow,esi,GW_CHILD
    invoke DestroyWindow,eax
    mov ebx,114
    mov ecx,35
    mov pt.x,6
    mov eax,124
    .if hw1==0
      mov hw1,esi
      mov edx,offset _lwa1
      mov pt.y,309
    .elseif hw2==0
      mov hw2,esi
      mov edx,offset _lwa2
      mov pt.y,344
    .elseif hw3==0
      mov hw3,esi
      mov edx,offset _lwa3
      mov pt.y,379
    .elseif hw4==0
      mov hw4,esi
      mov edx,offset _ulw1
      mov pt.x,eax
      mov pt.y,309
      mov ebx,ecx
    .elseif hw5==0
      mov hw5,esi
      mov edx,offset _ulw2
      mov pt.x,eax
      mov pt.y,344
      mov ebx,ecx
    .elseif hw6==0
      mov hw6,esi
      mov edx,offset _ulw3
      mov pt.x,eax
      mov pt.y,379
      mov ebx,ecx
    .endif
    invoke SetWindowText,esi,edx
    invoke ClientToScreen,hwnd,addr pt
    invoke GetWindowRect_,esi,addr rt
    mov eax,rt.bottom
    sub eax,rt.top
    invoke SetWindowPos,esi,0,pt.x,pt.y,ebx,eax,SWP_NOZORDER or SWP_FRAMECHANGED or SWP_SHOWWINDOW or SWP_NOACTIVATE
    mov eax,TRUE

  .elseif uMsg==WM_PAINT
    invoke BeginPaint,esi,addr ps
    mov ebx,eax
    invoke GetWindowText,esi,addr buf,255
    invoke GetClientRect,esi,addr rt
    invoke SelectObject,ebx,hfnt
    mov oldfnt,eax
    push rt.left
    mov edi,4
    add rt.top,edi
    sub rt.bottom,edi
    sub rt.right,edi
    mov eax,rt.right
    sub eax,20
    mov rt.left,eax
    invoke GetStockObject,WHITE_BRUSH
    invoke FillRect,ebx,addr rt,eax
    invoke SetBkMode,ebx,TRANSPARENT
    invoke SetTextColor,ebx,Black
    pop rt.left
    add rt.left,edi
    dec rt.top
    add rt.bottom,edi
    add rt.right,edi
    invoke DrawText,ebx,addr buf,-1,addr rt,DT_LEFT

    invoke GetWindowLong,esi,GWL_EXSTYLE
    mov edi,eax
    mov edx,WS_EX_LAYERED
    and eax,edx
    .if eax==0
      mov bfs.BlendOp,AC_SRC_OVER
      mov bfs.BlendFlags,0
      mov bfs.AlphaFormat,AC_SRC_OVER  ; (instead of AC_SRC_ALPHA)
      mov eax,200
      mov bfs.SourceConstantAlpha,al
      mov alph,eax
      mov lrd,LWA_ALPHA  ; (LWA_ALPHA=ULW_ALPHA=2, LWA_COLORKEY=ULW_COLORKEY=1)
      or edi,edx
      .if esi==hw1
        or edi,WS_EX_TRANSPARENT
        jmp @f
      .elseif esi==hw2
        mov alph,0
        jmp @f
      .elseif esi==hw3
        mov lrd,(LWA_ALPHA or LWA_COLORKEY)
@@:
        invoke SetWindowLong,esi,GWL_EXSTYLE,edi
        invoke SetLayeredWindowAttributes,esi,White,alph,lrd
        invoke SetWindowPos,esi,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE
      .elseif esi==hw4
        or edi,WS_EX_TRANSPARENT
        jmp @f
      .elseif esi==hw5
        mov bfs.SourceConstantAlpha,0
        jmp @f
      .elseif esi==hw6
        mov lrd,(ULW_ALPHA or ULW_COLORKEY)
@@:        
        invoke GetClientRect,esi,addr rt
        invoke CreateCompatibleDC,ebx
        mov hdcmem,eax        
    	  invoke CreateCompatibleBitmap,ebx,rt.right,rt.bottom
    	  invoke SelectObject,hdcmem,eax
    	  mov oldbmp,eax
        invoke BitBlt,hdcmem,0,0,rt.right,rt.bottom,ebx,0,0,SRCCOPY  ; or CAPTUREBLT
        invoke SetWindowLong,esi,GWL_EXSTYLE,edi
        invoke SetWindowPos,esi,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE
        invoke UpdateLayeredWindow,esi,ebx,0,addr rt+8,hdcmem,addr rt,White,addr bfs,lrd
        invoke SelectObject,hdcmem,oldbmp
        invoke DeleteObject,eax
        invoke DeleteDC,hdcmem
      .endif
    .endif
    invoke SelectObject,ebx,oldfnt
    invoke EndPaint,hWnd,addr ps
    mov eax,TRUE

  .elseif uMsg==WM_MOUSEWHEEL
    invoke PostMessage,hwnd,uMsg,wParam,lParam
    mov eax,TRUE    

  .else
    mov eax,FALSE
  .endif
  ret
DlgProc3 endp

;###########################################################################################

DlgProc2 proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local pt:POINT
  local rt:RECT
  
  .if uMsg==WM_INITDIALOG
    mov eax,hWnd
    mov hw7,eax
    invoke EnableWindow,hwnd,TRUE
    mov pt.x,14
    mov pt.y,184
    invoke ClientToScreen,hwnd,addr pt    
    mov ecx,136
    mov edx,20
    invoke SetWindowPos,hWnd,0,pt.x,pt.y,ecx,edx,SWP_NOZORDER or SWP_FRAMECHANGED or SWP_NOACTIVATE
    invoke SetWindowText,hWnd,offset _other
    invoke GetWindow,hWnd,GW_CHILD
    invoke ShowWindow,eax,SW_MAXIMIZE
    mov eax,TRUE
    
  .elseif uMsg==WM_MOUSEWHEEL
    invoke PostMessage,hwnd,uMsg,wParam,lParam
    mov eax,TRUE
    
  .else
    mov eax,FALSE
  .endif
  ret
DlgProc2 endp

;###########################################################################################

ThreadProc proc lParam:LPARAM
  invoke DialogBoxParam,hinst,id2,hwnd,offset DlgProc2,0
  ret
ThreadProc endp

;###########################################################################################

OnInit proc uses ebx edi hWnd:HWND
  local rt:RECT
  local wc:WNDCLASSEX
  local mii:MENUITEMINFO
  local var:DWORD  
  local buf[256]:BYTE

  xor eax,eax
;  mov fixpt,eax
;  mov fixhw,eax
;  mov fixpid,eax
;  mov dis,eax
;  mov transp,eax
;  mov topl,eax
;  mov frame,eax
;  mov rad,eax
;  mov nc_test,eax
  inc eax
  mov timer,eax
  mov rect,eax
  mov rgn,eax
  mov inv,eax

  mov eax,hWnd
  mov hwnd,eax

  invoke SetWindowText,hWnd,offset _app

  invoke GetMenu,hWnd
  mov hmenubar,eax
;  invoke GetSubMenu,eax,19
;  mov hmenupop1,eax
;  invoke GetSubMenu,eax,20
;  mov hmenupop2,eax

  invoke GetDesktopWindow
  mov hwdesk,eax
  invoke FindWindowEx,HWND_MESSAGE,0,0,0
  invoke GetAncestor,eax,GA_PARENT
  mov hwmess,eax

  invoke LoadIcon,hinst,id
;  invoke SendMessage,hWnd,WM_SETICON,ICON_BIG,eax
  invoke SetClassLong,hWnd,GCL_HICON,eax
  
  invoke SendMessage,hWnd,WM_GETFONT,0,0
  mov hfnt,eax
  
  invoke CreateFontIndirect,offset logfont
  mov hfont,eax

  invoke CreateThread,0,0,offset ThreadProc,0,0,0
  invoke CloseHandle,eax                          

  xor edi,edi
  .while edi<=5
    invoke CreateDialogParam,hinst,id2,hWnd,offset DlgProc3,0
    inc edi
  .endw

  mov wc.cbSize,sizeof wc  ; <<frame for fixed window>>
  mov wc.style,0
  mov wc.lpfnWndProc,DefWindowProc
  mov wc.cbClsExtra,0
  mov wc.cbWndExtra,0
  mov eax,hinst
  mov wc.hInstance,eax
  xor eax,eax
  mov wc.hIcon,eax
  mov wc.hIconSm,eax
  invoke LoadCursor,0,IDC_HAND
  mov wc.hCursor,eax
  mov var,5555AAAAh
  invoke CreateBitmap,2,2,1,1,addr var
  push eax
  invoke CreatePatternBrush,eax
  mov hbrush,eax
  mov wc.hbrBackground,eax
  call DeleteObject  
  mov wc.lpszMenuName,0
  mov wc.lpszClassName,offset _winrect
  invoke RegisterClassEx,addr wc
  mov wc.style,CS_DBLCLKS
  mov wc.lpfnWndProc,offset HTShapeProc
  mov wc.lpszClassName,offset _htshape
  invoke RegisterClassEx,addr wc

  xor edi,edi
  .while edi<=3
    invoke CreateWindowEx,WS_EX_TOPMOST or WS_EX_TOOLWINDOW or WS_EX_TRANSPARENT or WS_EX_LAYERED,offset _winrect,0,WS_POPUP,0,0,0,0,0,0,hinst,0
    push eax
    invoke SetLayeredWindowAttributes,eax,0,255,LWA_ALPHA
    inc edi
  .endw
  pop hwbottom
  pop hwright
  pop hwtop
  pop hwleft

  invoke GetDlgItem,hWnd,id  ; <<listbox>>
  mov ebx,eax
  mov hwlb,ebx
  invoke SetWindowLong,ebx,GWL_WNDPROC,offset SubClassListBox
  invoke SetWindowLong,ebx,GWL_USERDATA,eax
  invoke GetWindowRect_,ebx,addr rt
  invoke MapWindowPoints,0,hWnd,addr rt,2
  mov eax,rt.left
  mov leftinit,eax
  mov eax,rt.top
  mov topinit,eax
  invoke SendMessage,ebx,WM_SETFONT,hfont,1
  invoke SendDlgItemMessage,hWnd,id-10,WM_SETFONT,hfont,1
  invoke SendDlgItemMessage,hWnd,id-11,WM_SETFONT,hfont,1
  invoke SendDlgItemMessage,hWnd,id-12,WM_SETFONT,hfont,1
  invoke SetDlgItemText,hWnd,id-12,offset _head
  invoke SendDlgItemMessage,hWnd,id-13,WM_SETFONT,hfont,1

  invoke CreateRectRgn,0,0,0,0
  mov hregion,eax

  invoke CreateRectRgn,0,0,0,0
  mov hrgn,eax
  
  invoke GetDlgItem,hWnd,id-5  ; <<rgn>>
  mov ebx,eax
  invoke GetWindowRect_,ebx,addr rt
  mov eax,rt.left
  sub rt.right,eax
  mov eax,rt.top
  sub rt.bottom,eax
  xor eax,eax
  mov rt.left,eax
  mov rt.top,eax
  invoke CreateRectRgn,rt.left,rt.top,rt.right,rt.bottom
  mov edi,eax
  mov eax,20
  mov rt.left,eax
  mov rt.top,eax
  sub rt.right,eax
  sub rt.bottom,eax
  invoke CreateRectRgn,rt.left,rt.top,rt.right,rt.bottom
  push eax
  invoke CombineRgn,edi,edi,eax,RGN_DIFF
  call DeleteObject
  invoke SetWindowRgn,ebx,edi,1
  
  invoke GetDlgItem,hWnd,id-6  ; <<!ws_child>>
  mov ebx,eax
  invoke GetWindowLong,ebx,GWL_STYLE
  and eax,not WS_CHILD
  invoke SetWindowLong,ebx,GWL_STYLE,eax
  invoke SetWindowPos,ebx,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE

  invoke GetDlgItem,hWnd,id-9  ; <<layoutrtl>>
  mov ebx,eax
  invoke SetWindowText,ebx,offset _layoutrtl
  invoke SetWindowLong,ebx,GWL_WNDPROC,offset SubClassLayoutrtl
  invoke SetWindowLong,ebx,GWL_USERDATA,eax
  invoke CreateWindowEx,WS_EX_STATICEDGE,offset _static,offset _rq,WS_CHILD or WS_VISIBLE or SS_CENTERIMAGE or SS_CENTER or SS_NOTIFY,2,20,26,22,ebx,id,hinst,0
  invoke SendMessage,eax,WM_SETFONT,hfnt,1

  invoke GetSystemMenu,hWnd,0
  mov ebx,eax
  mov mii.cbSize,sizeof MENUITEMINFO
  mov mii.fMask,MIIM_FTYPE
  invoke GetMenuItemInfo,ebx,0,TRUE,addr mii
  mov mii.fType,MFT_MENUBREAK
  invoke SetMenuItemInfo,ebx,0,TRUE,addr mii

  invoke SetTimer,hWnd,id,100,0
  ret
OnInit endp

;###########################################################################################

;PopupMenuInput proc uses ebx edi esi
;  local pt:POINT
;  
;  invoke GetCursorPos,addr pt
;  invoke WindowFromPoint,pt.x,pt.y
;  mov ebx,eax
;
;;  invoke GetSubMenu,hmenubar,19
;;  mov esi,eax
;;  invoke GetSubMenu,edi,20
;
;  invoke MenuItemFromPoint,ebx,eax,pt.x,pt.y
;  mov edi,eax
;  invoke GetMenuItemID,esi,eax
;
;
;  ret
;PopupMenuInput endp

;###########################################################################################

DlgProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  local pt:POINT
  local rt:RECT
  local ps:PAINTSTRUCT
  local buf[1024]:BYTE
  local style:DWORD  
  local exstyle:DWORD
  local clstyle:DWORD
  local userdata:DWORD
  local var:DWORD

  mov edx,wParam
  mov ecx,lParam
  
  .if uMsg==WM_CLOSE
    invoke ShowWindow,hWnd,SW_HIDE
    invoke KillTimer,hWnd,id
    invoke DeleteObject,hbrush
    invoke DeleteObject,hfont
    invoke DeleteObject,hrgn
    invoke DeleteObject,hregion
    invoke EndDialog,hWnd,0
    mov eax,TRUE

  .elseif uMsg==WM_TIMER
    invoke RefreshInfo,-1
    mov eax,TRUE

  .elseif uMsg==WM_INITDIALOG
    invoke OnInit,hWnd
    invoke RefreshInfo,-1
    invoke UpdateMenu
    mov eax,TRUE

  .elseif uMsg==WM_WINDOWPOSCHANGING
    mov ebx,ecx
    assume ebx:PTR WINDOWPOS
    mov eax,[ebx].flags
    assume ebx:nothing    
    and eax,SWP_NOSIZE
    .if eax!=0
      invoke GetWindowRect_,hw5,addr rt
      invoke MapWindowPoints,0,hWnd,addr rt,2
      invoke InvalidateRect,hWnd,addr rt,1
    .endif
    mov eax,FALSE

  .elseif uMsg==WM_MOVE
    invoke OnMove
    invoke FixFrame,fixhw
    mov eax,TRUE

  .elseif uMsg==WM_SIZE
    mov edi,ecx
    mov esi,edi
    and esi,0FFFFh
    sub esi,leftinit
    shr edi,16
    sub edi,topinit
    invoke SetWindowPos,hwlb,0,0,0,esi,edi,SWP_NOZORDER or SWP_NOMOVE or SWP_FRAMECHANGED or SWP_NOACTIVATE
    xor edi,edi
    push id-12
    push id-10
    .while edi<=1
      pop eax
      invoke GetDlgItem,hWnd,eax
      mov ebx,eax
      invoke GetWindowRect_,ebx,addr rt
      mov eax,rt.top
      sub rt.bottom,eax
      invoke SetWindowPos,ebx,0,0,0,esi,rt.bottom,SWP_NOZORDER or SWP_NOMOVE or SWP_FRAMECHANGED or SWP_NOACTIVATE
      inc edi
    .endw
    invoke FixFrame,fixhw
    mov eax,TRUE

;  .elseif uMsg==WM_ENTERIDLE && edx==MSGF_MENU
;    invoke GetCursorPos,addr pt
;    invoke WindowFromPoint,pt.x,pt.y
;    .if eax==lParam
;      invoke Beep,8000,100
;      
;      invoke SendMessage,lParam,MN_GETHMENU,0,0
;      jmp @f
;    .endif
;    xor eax,eax

  .elseif uMsg==WM_SETCURSOR && edx==hWnd && cx==HTMENU
    invoke GetCursorPos,addr pt
    invoke GetMenu,hWnd
@@:
    mov esi,eax
    invoke MenuItemFromPoint,hWnd,eax,pt.x,pt.y
    mov edi,eax
    invoke GetMenuItemID,esi,eax
    mov ebx,eax
    invoke GetTickCount            
    .if ebx!=olditem
      mov olditem,ebx
      mov oldtick,eax
    .else  ; if ebx==olditem
      .if oldtick==0
        mov oldtick,eax
      .else
        mov edx,eax
        sub edx,oldtick
        .if edx>10000
          mov oldtick,eax
        .else
          .if edx>2000
            xor eax,eax
            mov oldtick,eax
            mov edx,ebx
            .if (edx>=id && edx<=id+13) || edx==id+16
              jmp @f
            .elseif edi>=17 && edi<=20
              invoke GetSubMenu,esi,edi
              invoke TrackPopupMenuEx,eax,\
                TPM_LEFTALIGN or TPM_TOPALIGN or TPM_RETURNCMD or TPM_LEFTBUTTON or TPM_NOANIMATION or TPM_HORIZONTAL or TPM_RECURSE,\ ; or TPM_NONOTIFY,\
                pt.x,pt.y,hWnd,0
                xor eax,eax
              ret
            .elseif edi>=id2-2 && edi<=id2+21 && fixhw!=0
              invoke GetKeyState,VK_CONTROL
              and eax,8000h
              xor esi,esi
              .if eax!=0
                inc esi
              .endif
              jmp @1
            .elseif edi>=id+19 && edi<=id+22 && fixhw!=0
              jmp @2
            .elseif edi>=id+31 && edi<=id+47 && fixhw!=0
              jmp @3
            .elseif edi==id+30
              jmp @4
            .endif
          .endif
        .endif
      .endif
    .endif
    xor eax,eax

  .elseif uMsg==WM_COMMAND && ecx==0 && ((edx>=id && edx<=id+13) || edx==id+16)
@@:
    xor eax,eax
    .if edx==id
      xor topl,1
    .elseif edx==id+1
      xor inv,1
    .elseif edx==id+2
      xor dis,1
    .elseif edx==id+3
      xor transp,1
    .elseif edx==id+4
      xor rgn,1
    .elseif edx==id+5
      mov fixpt,eax
      invoke SetCursorPos,point.x,point.y
    .elseif edx==id+6
      mov fixpid,eax
    .elseif edx==id+7
      xor timer,1
      .if timer!=0
        invoke SetTimer,hWnd,id,100,0
      .else
        invoke KillTimer,hWnd,id
      .endif
    .elseif edx==id+8
      xor rect,1
    .elseif edx==id+9
      mov fixhw,eax
      invoke FixFrame,eax
    .elseif edx==id+16
      xor frame,1
    .elseif edx>=id+10 && edx<=id+13
      sub edx,id+10
      mov rad,edx
    .endif
    invoke RefreshInfo,-1
    invoke UpdateMenu
;    invoke InvalidateRect,hWnd,0,1
    mov eax,TRUE

  .elseif uMsg==WM_MENURBUTTONUP && fixhw!=0 && wParam!=0
    invoke GetMenu,hWnd
    invoke GetSubMenu,eax,19  ; 'ht' menubar item
    .if eax==lParam
      mov edi,wParam
      sub edi,4
      xor esi,esi
      inc esi
      jmp @f
    .endif

  .elseif uMsg==WM_COMMAND && ecx==0 && edx>=id2-2 && edx<=id2+21 && fixhw!=0
    mov edi,edx
    xor esi,esi
@1:
    sub edi,id2
@@:
    invoke SetWindowText,hWnd,offset _wait
    invoke IsWindow,fixhw
    .if eax==0
      mov fixhw,eax
    .else
      invoke Beep,5000,100
      invoke HT_region_info,fixhw,addr buf,edi,esi
      invoke SetDlgItemText,hWnd,id-10,addr buf
      invoke Beep,5000,100
    .endif
    invoke SetWindowText,hWnd,offset _app
    mov eax,TRUE

  .elseif uMsg==WM_COMMAND && ecx==0 && edx>=id+31 && edx<=id+47
@3:
    xor edi,edi  
    mov esi,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE
    invoke IsWindow,fixhw
    .if eax!=0
      invoke GetWindowLong,fixhw,GWL_EXSTYLE
      mov exstyle,eax
      invoke GetWindowLong,fixhw,GWL_STYLE
      mov style,eax
      mov edx,wParam
      .if edx==id+31
        invoke IsWindowEnabled,fixhw
        .if eax==0
          mov eax,TRUE
        .else
          xor eax,eax
        .endif
        invoke EnableWindow,fixhw,eax
      .elseif edx==id+40
        invoke IsWindowVisible,fixhw
        .if eax==0
          mov eax,TRUE
        .else
          mov eax,FALSE
        .endif
        invoke SendMessage,fixhw,WM_SETREDRAW,eax,0
;        invoke SendNotifyMessage,fixhw,WM_SETREDRAW,eax,0
;        invoke PostMessage,fixhw,WM_SETREDRAW,eax,0
;        invoke DefWindowProc,fixhw,WM_SETREDRAW,eax,0
;;        invoke InvalidateRect,0,0,1
      .elseif edx==id+47
        .if rgnflag==0
          inc rgnflag
          invoke GetWindowRgn,fixhw,hregion
          invoke SetWindowRgn,fixhw,0,1
        .else
          mov rgnflag,0
          invoke SetWindowRgn,fixhw,hregion,1
        .endif
      .elseif edx==id+46
        mov eax,style
        xor eax,WS_THICKFRAME
        jmp @f
      .elseif edx==id+45
        mov eax,style
        xor eax,WS_VISIBLE
        jmp @f
      .elseif edx==id+41
        mov eax,style
        xor eax,WS_DISABLED
@@:
        invoke SetWindowLong,fixhw,GWL_STYLE,eax
      .elseif edx==id+39
        invoke IsIconic,fixhw
        .if eax==0
          mov eax,SW_MINIMIZE
        .else
          mov eax,SW_RESTORE
        .endif
        invoke ShowWindow,fixhw,eax
      .elseif edx==id+38
        invoke IsWindowVisible,fixhw
        .if eax==0
          mov eax,SW_SHOWNOACTIVATE
        .else
          mov eax,SW_HIDE
        .endif
        invoke ShowWindow,fixhw,eax
      .elseif edx==id+32
        invoke IsWindowVisible,fixhw
        .if eax==0
          mov esi,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE or SWP_SHOWWINDOW
        .else
          mov esi,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE or SWP_HIDEWINDOW
        .endif
      .elseif edx==id+42
        mov eax,exstyle
        xor eax,WS_EX_NOACTIVATE
        jmp @f
      .elseif edx==id+43
        mov eax,exstyle
        xor eax,WS_EX_COMPOSITED
        jmp @f
      .elseif edx==id+44
        mov eax,exstyle
        xor eax,WS_EX_LAYERED
        jmp @f
      .elseif edx==id+33
        mov eax,exstyle
        xor eax,WS_EX_TRANSPARENT
@@:
        invoke SetWindowLong,fixhw,GWL_EXSTYLE,eax
      .elseif edx==id+34
        mov edi,HWND_TOPMOST
        mov esi,SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE                
      .elseif edx==id+35
        mov edi,HWND_NOTOPMOST
        mov esi,SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE        
      .elseif edx==id+36
        mov edi,HWND_TOP
        mov esi,SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE
      .elseif edx==id+37
        mov edi,HWND_BOTTOM
        mov esi,SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE
      .endif
      invoke SetWindowPos,fixhw,edi,0,0,0,0,esi
      invoke RefreshInfo,-1
;      invoke InvalidateRect,hWnd,0,1
    .endif
    jmp @4

  .elseif uMsg==WM_COMMAND && ecx==0 && edx==id+30
@4:
    mov ebx,fixhw
    .if ebx!=0
      invoke IsWindow,ebx
      .if eax==0
        mov fixhw,eax
      .else
        invoke GetWindowLong,ebx,GWL_USERDATA
        mov userdata,eax
        invoke GetWindowLong,ebx,GWL_STYLE
        mov style,eax
        invoke GetWindowLong,ebx,GWL_EXSTYLE
        mov exstyle,eax
        invoke GetClassLong,ebx,GCL_STYLE
        mov clstyle,eax
        invoke GetClassLong,ebx,GCL_CBWNDEXTRA
        mov edi,eax
        invoke GetClassLong,ebx,GCL_CBCLSEXTRA
        mov esi,eax
        invoke GetWindowRect,ebx,addr rt
        mov ecx,rt.right
        sub ecx,rt.left
        mov edx,rt.bottom
        sub edx,rt.top
        invoke wsprintf,addr buf,offset _more,ebx,style,exstyle,clstyle,edi,esi,userdata,rt.left,rt.top,ecx,edx
        invoke SetDlgItemText,hWnd,id-10,addr buf
      .endif
    .endif
    mov eax,TRUE

  .elseif uMsg==WM_COMMAND && ecx==0 && edx>=id+19 && edx<=id+22
    mov edi,edx
@2:
    xor esi,esi
    .if edi==id+19
      mov edi,offset _rundll
      mov esi,offset _param
      invoke ShowWindow,hWnd,SW_MINIMIZE
      jmp @f
    .elseif edi==id+20
      mov edi,offset _url_0
      jmp @f
    .elseif edi==id+21
      mov edi,offset _url_1
      jmp @f
    .elseif edi==id+22
      mov edi,offset _url_2
@@:
      invoke ShellExecute,0,offset _open,edi,esi,0,SW_SHOWNORMAL
    .endif
    mov eax,TRUE

  .elseif uMsg==WM_COMMAND && ecx!=0 && edx==id-12
    invoke GetDlgItemText,hWnd,id-12,addr buf,255
    invoke SetDlgItemText,hWnd,id-10,addr buf
    mov eax,TRUE

  .elseif uMsg==WM_COMMAND && ecx!=0 && edx==id-4
    push hw6
    push hw5
    push hw4
    push hw3
    push hw2
    push hw1
    xor esi,esi
    .while esi<6
      pop ebx
      invoke GetWindowLong,ebx,GWL_EXSTYLE
      xor eax,WS_EX_COMPOSITED
      invoke SetWindowLong,ebx,GWL_EXSTYLE,eax
      invoke SetWindowPos,ebx,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_NOACTIVATE
      inc esi
    .endw
    jmp @f

  .elseif uMsg==WM_COMMAND && ecx!=0 && edx>=id-15 && edx<=id-13
@@:
    invoke RefreshInfo,-1
    mov eax,TRUE

  .elseif uMsg==WM_LBUTTONDOWN
    invoke DefWindowProc,hWnd,WM_SYSCOMMAND,SC_SIZE+9,0
    mov eax,TRUE

  .elseif uMsg==WM_LBUTTONDBLCLK
    invoke IsZoomed,hWnd
    .if eax==0
      mov eax,SC_MAXIMIZE
    .else
      mov eax,SC_RESTORE
    .endif  
    invoke DefWindowProc,hWnd,WM_SYSCOMMAND,eax,0
    mov eax,TRUE

  .elseif uMsg==WM_MOUSEWHEEL
    invoke RefreshInfo,-1
    mov eax,TRUE

  .elseif uMsg==WM_CTLCOLORDLG
    jmp @f
  .elseif uMsg==WM_CTLCOLORSTATIC
    invoke GetDlgCtrlID,lParam
    .if eax==id-16
      invoke SetBkMode,wParam,TRANSPARENT
      invoke SetTextColor,wParam,White
@@:
      invoke GetStockObject,LTGRAY_BRUSH
    .else
      mov eax,FALSE    
    .endif

  .elseif uMsg==WM_PAINT
    invoke BeginPaint,hWnd,addr ps
    mov ebx,eax
    invoke GetWindowRect_,hw2,addr rt
    invoke MapWindowPoints,0,hWnd,addr rt,2
    invoke GetStockObject,WHITE_BRUSH
    invoke FrameRect,ebx,addr rt,eax
    invoke SelectObject,ebx,hfnt
    mov edi,eax
    invoke SetBkMode,ebx,TRANSPARENT
    invoke SetTextColor,ebx,White
    add rt.top,3
    add rt.left,4
    invoke DrawText,ebx,offset _lwa2,-1,addr rt,DT_LEFT
    invoke GetWindowRect_,hw5,addr rt
    invoke MapWindowPoints,0,hWnd,addr rt,2
    invoke GetStockObject,WHITE_BRUSH
    invoke FrameRect,ebx,addr rt,eax
    add rt.top,3
    add rt.left,4
    invoke DrawText,ebx,offset _ulw2,-1,addr rt,DT_LEFT
    invoke SetTextColor,ebx,White
    mov rt.left,6
    mov rt.top,278
    mov rt.right,200
    mov rt.bottom,318
    invoke DrawText,ebx,offset _layered,-1,addr rt,DT_LEFT
    invoke GetSystemMetrics,SM_DBCSENABLED
    .if eax!=0
      mov al,'1'
    .else
      mov al,'0'
    .endif
    mov byte ptr [_imm+59],al
    invoke GetSystemMetrics,SM_IMMENABLED
    .if eax!=0
      mov al,'1'
    .else
      mov al,'0'
    .endif
    mov byte ptr [_imm+93],al
    mov rt.left,7
    mov rt.top,450
    add rt.right,20
    mov rt.bottom,494
    invoke DrawText,ebx,offset _imm,-1,addr rt,DT_LEFT
    mov rt.left,10
    mov rt.top,494
    add rt.right,20
    mov rt.bottom,544
    invoke DrawText,ebx,offset _ime,-1,addr rt,DT_LEFT    
    invoke SelectObject,ebx,edi
    invoke EndPaint,hWnd,addr ps
    mov eax,TRUE

	.else
    xor eax,eax
  .endif
  ret
DlgProc endp

;###########################################################################################

start:
  invoke GetModuleHandle,0
  mov hinst,eax
  invoke DialogBoxParam,eax,id,0,offset DlgProc,0
  invoke ExitProcess,eax
  invoke InitCommonControls
end start

;###########################################################################################
